Index: src/http/modules/ngx_http_rewrite_module.c
===================================================================
--- src/http/modules/ngx_http_rewrite_module.c	(revision 5129)
+++ src/http/modules/ngx_http_rewrite_module.c	(working copy)
@@ -358,9 +358,11 @@
         || ngx_strncmp(value[2].data, "https://", sizeof("https://") - 1) == 0
         || ngx_strncmp(value[2].data, "$scheme", sizeof("$scheme") - 1) == 0)
     {
-        regex->status = NGX_HTTP_MOVED_TEMPORARILY;
-        regex->redirect = 1;
-        last = 1;
+        if (!(cf->args->nelts == 4 && ngx_strcmp(value[3].data, "noredirect") == 0)) {
+            regex->status = NGX_HTTP_MOVED_TEMPORARILY;
+            regex->redirect = 1;
+            last = 1;
+        }
     }
 
     if (cf->args->nelts == 4) {
@@ -371,6 +373,10 @@
             regex->break_cycle = 1;
             last = 1;
 
+        } else if (ngx_strcmp(value[3].data, "noredirect") == 0) {
+            regex->break_cycle = 1;
+            last = 1;
+
         } else if (ngx_strcmp(value[3].data, "redirect") == 0) {
             regex->status = NGX_HTTP_MOVED_TEMPORARILY;
             regex->redirect = 1;
